require 'picture_io'
class PictureIO
  class LocalPicture
    def initialize base_dir = Rails.root + 'public/images/'
      @base = base_dir
    end
    
    def base
      @base
    end
    
    def base=(b)
      @base = b
    end
    
    def self.subdirs
      ['', 'v', 'h', 'vh', 'thumbnail']
    end
    
    def dir(subdir = nil)
      sd = if subdir.to_s.empty?
        self.base
      else
        self.base + (subdir.to_s + '/')
      end
      sd
    end
    
    def mkdir subdir = nil
      Dir.mkdir(base) unless File.exist?(base)
      return if subdir.to_s.empty?
      Dir.mkdir(dir(subdir)) unless File.exist?(dir(subdir))
    end
    
    def exist?(filename, subdir = nil)
      begin
        File.exist?(dir(subdir) + filename)
      rescue StandardError
        false
      end
    end
    
    def put(bindata, filename, subdir = nil)
      mkdir subdir
      begin
        open(dir(subdir) + filename, 'wb') do |f|
          f.write bindata
        end
        true
      rescue StandardError
        false
      end
    end
    
    def get(filename, subdir = nil)
      bindata = ''
      begin
        open(dir(subdir) + filename, 'rb') do |f|
          bindata += f.read
        end
        bindata
      rescue StandardError
        false
      end
    end
    
    def delete(filename, subdir = nil)
      begin
        File.delete(dir(subdir) + filename)
        true
      rescue StandardError
        false
      end
    end
    
  end
end
