require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe CommonLicensesController do

  # This should return the minimal set of attributes required to create a valid
  # CommonLicense. As you add validations to CommonLicense, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all common_licenses as @common_licenses" do
      common_license = CommonLicense.create! valid_attributes
      get :index
      assigns(:common_licenses).should eq([common_license])
    end
  end

  describe "GET show" do
    it "assigns the requested common_license as @common_license" do
      common_license = CommonLicense.create! valid_attributes
      get :show, :id => common_license.id
      assigns(:common_license).should eq(common_license)
    end
  end

  describe "GET new" do
    it "assigns a new common_license as @common_license" do
      get :new
      assigns(:common_license).should be_a_new(CommonLicense)
    end
  end

  describe "GET edit" do
    it "assigns the requested common_license as @common_license" do
      common_license = CommonLicense.create! valid_attributes
      get :edit, :id => common_license.id
      assigns(:common_license).should eq(common_license)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new CommonLicense" do
        expect {
          post :create, :common_license => valid_attributes
        }.to change(CommonLicense, :count).by(1)
      end

      it "assigns a newly created common_license as @common_license" do
        post :create, :common_license => valid_attributes
        assigns(:common_license).should be_a(CommonLicense)
        assigns(:common_license).should be_persisted
      end

      it "redirects to the created common_license" do
        post :create, :common_license => valid_attributes
        response.should redirect_to(CommonLicense.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved common_license as @common_license" do
        # Trigger the behavior that occurs when invalid params are submitted
        CommonLicense.any_instance.stub(:save).and_return(false)
        post :create, :common_license => {}
        assigns(:common_license).should be_a_new(CommonLicense)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        CommonLicense.any_instance.stub(:save).and_return(false)
        post :create, :common_license => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested common_license" do
        common_license = CommonLicense.create! valid_attributes
        # Assuming there are no other common_licenses in the database, this
        # specifies that the CommonLicense created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        CommonLicense.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => common_license.id, :common_license => {'these' => 'params'}
      end

      it "assigns the requested common_license as @common_license" do
        common_license = CommonLicense.create! valid_attributes
        put :update, :id => common_license.id, :common_license => valid_attributes
        assigns(:common_license).should eq(common_license)
      end

      it "redirects to the common_license" do
        common_license = CommonLicense.create! valid_attributes
        put :update, :id => common_license.id, :common_license => valid_attributes
        response.should redirect_to(common_license)
      end
    end

    describe "with invalid params" do
      it "assigns the common_license as @common_license" do
        common_license = CommonLicense.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        CommonLicense.any_instance.stub(:save).and_return(false)
        put :update, :id => common_license.id, :common_license => {}
        assigns(:common_license).should eq(common_license)
      end

      it "re-renders the 'edit' template" do
        common_license = CommonLicense.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        CommonLicense.any_instance.stub(:save).and_return(false)
        put :update, :id => common_license.id, :common_license => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested common_license" do
      common_license = CommonLicense.create! valid_attributes
      expect {
        delete :destroy, :id => common_license.id
      }.to change(CommonLicense, :count).by(-1)
    end

    it "redirects to the common_licenses list" do
      common_license = CommonLicense.create! valid_attributes
      delete :destroy, :id => common_license.id
      response.should redirect_to(common_licenses_url)
    end
  end

end
